﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication13
{
  public partial class MainPage : UserControl
  {
    public MainPage()
    {
      InitializeComponent();
    }
    void OnClick(object sender, RoutedEventArgs args)
    {
      gridContent.Children.Clear();

      storyBoard = new Storyboard();
      storyBoard.Duration = new Duration(new TimeSpan(0, 0, 5));
      
      int offsetZ = -192;
      int offsetX = -192;

      for (int i = 0; i < 6; i++)
      {
        Rectangle r = new Rectangle()
        {
          Width = 192,
          Height = 96,
          Fill = Colors[i],
          Projection = new PlaneProjection()
        };               

        gridContent.Children.Add(r);

        DoubleAnimation daRotationY = new DoubleAnimation()
        {
          To = -45
        };
        Storyboard.SetTarget(daRotationY, r.Projection);
        Storyboard.SetTargetProperty(daRotationY, new PropertyPath("RotationY"));
        storyBoard.Children.Add(daRotationY);

        DoubleAnimation daOffsetX = new DoubleAnimation()
        {
          To = offsetX
        };
        Storyboard.SetTarget(daOffsetX, r.Projection);
        Storyboard.SetTargetProperty(daOffsetX, new PropertyPath("GlobalOffsetX"));
        storyBoard.Children.Add(daOffsetX);
        offsetX += 64;

        DoubleAnimation daOffsetZ = new DoubleAnimation()
        {
          To = offsetZ
        };
        Storyboard.SetTarget(daOffsetZ, r.Projection);
        Storyboard.SetTargetProperty(daOffsetZ, new PropertyPath("GlobalOffsetZ"));
        storyBoard.Children.Add(daOffsetZ);
        offsetZ += 64;
      }
      storyBoard.Begin();
    }
    Storyboard storyBoard;

    static Brush[] Colors = {
      new SolidColorBrush(Color.FromArgb(0xFF, 0xFF, 0x00, 0x00)),
      new SolidColorBrush(Color.FromArgb(0xFF, 0x00, 0xFF, 0x00)),
      new SolidColorBrush(Color.FromArgb(0xFF, 0x00, 0x00, 0xFF)),
      new SolidColorBrush(Color.FromArgb(0xFF, 0xFF, 0xFF, 0x00)),
      new SolidColorBrush(Color.FromArgb(0xFF, 0x00, 0xFF, 0xFF)),
      new SolidColorBrush(Color.FromArgb(0xFF, 0xFF, 0x00, 0xFF))
    };
  }
}
